=== debian/changelog ===
tcc (0.9.27~git20161217.cd9514ab-3ubuntu1) zesty; urgency=medium

  * Disable stack protection where it is enabled by default as well

 -- Graham Inggs <gingg@ubuntu.com>  Tue, 07 Feb 2017 11:00:03 +0200

tcc (0.9.27~git20161217.cd9514ab-3) unstable; urgency=medium

  * debian/patches:
    + Disable stack protection when building libtcc1.a or tcc fails to link
      against it, as happens in test3.

 -- Thomas Preud'homme <robotux@debian.org>  Sun, 18 Dec 2016 16:06:55 +0000

tcc (0.9.27~git20161217.cd9514ab-2) unstable; urgency=medium

  * Fix disabling of broken test on i386.
  * Enable build on arm64.

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 17 Dec 2016 22:55:20 +0000

tcc (0.9.27~git20161217.cd9514ab-1) unstable; urgency=medium

  * New upstream snapshot (Closes: #786905, #775992, #824473, #675024,
    #698351, #770657).
  * debian/patches:
    + Skip a test broken for i386.
    + Fix version string to match package version (Closes: #786908).
  * Update configure step and dh_install steps considering upstream changes.
  * Switch to secure URIs for Vcs fields.
  * Bump Standards-Version to 3.9.8 (no changes needed).
  * Enable all hardening.
  * debian/watch: simplify and enable signature checking.

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 17 Dec 2016 21:29:50 +0000
