=== debian/changelog ===
tcc (0.9.27-5) unstable; urgency=medium

  * debian/control:
    + Update Vcs fields.
  * debian/patches:
    + update forwarded status of the patch.
    + add patch fixing -pthread option handling (Closes: #891592, thanks
      Vincent Lefevre).

 -- Thomas Preud'homme <robotux@debian.org>  Wed, 28 Feb 2018 21:03:17 +0000

tcc (0.9.27-4) unstable; urgency=medium

  * debian/patches:
    + Fix patch disabling stack protector.

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 24 Feb 2018 16:47:28 +0000

tcc (0.9.27-3) unstable; urgency=medium

  * debian/patches:
    + Guard dead code on non x86 target to fix armel build.
  * debian/rules:
    + Run tests sequentially to fix test failure on i386.

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 24 Feb 2018 16:28:50 +0000

tcc (0.9.27-2) unstable; urgency=medium

  * debian/patches:
    + Rework patch to disable stack protector to work on systems where stack
      protector is the default for the compiler (Closes: #854471, thanks
      Graham Inggs).

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 24 Feb 2018 00:19:16 +0000

tcc (0.9.27-1) unstable; urgency=medium

  * New upstream release (Closes: #884664).
  * debian/copyright:
    + Update copyright information.
    + Use secure format URL.
  * debian/compat:
    + Bump debhelper compat.
  * debian/control:
    + Update versioned dependency on debhelper.
    + Use canonical URL for Vcs-Browser.
    + Bump standard version (no changes needed).
  * debian/watch:
    + Use secure URL.

 -- Thomas Preud'homme <robotux@debian.org>  Fri, 23 Feb 2018 23:39:54 +0000
