=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: tcc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Preud'homme <robotux@debian.org>
+Maintainer: Thomas Preud'homme <robotux@debian.org>
 Uploaders: Matteo Cypriani <mcy@lm7.fr>
-Build-Depends: debhelper (>= 9), texinfo, perl
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11), texinfo, perl
+Standards-Version: 4.1.3
 Homepage: http://www.tinycc.org/
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/tcc.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/tcc.git
+Vcs-Browser: https://salsa.debian.org/debian/tcc
+Vcs-Git: https://salsa.debian.org/debian/tcc.git
 
 Package: tcc
 Architecture: hurd-i386 i386 amd64 armel armhf arm64
