=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 	sed 's/\(TCC_ARM_VERSION\) .*/\1 7/' config.h
 endif
 endif
+
+override_dh_auto_test:
+	dh_auto_test --no-parallel
 
 override_dh_auto_clean:
 	[ ! -f config.mak ] || dh_auto_clean
